
# line 68 "gram.y"
#include <stdio.h>
#include <ctype.h>
#include "twm.h"
#include "menus.h"
#include "icons.h"
#include "add_window.h"
#include "list.h"
#include "util.h"
#include "screen.h"
#include "parse.h"
#include <X11/Xos.h>
#include <X11/Xmu/CharSet.h>

static char *Action = "";
static char *Name = "";
static char *defstring = "default";
static MenuRoot	*root, *pull = NULL;
static char *curWorkSpc;
static char *client, *workspace;
static MenuItem *lastmenuitem = (MenuItem*) 0;

static MenuRoot *GetRoot();

static Bool CheckWarpScreenArg(), CheckWarpRingArg();
static Bool CheckColormapArg();
static void GotButton(), GotKey(), GotTitleButton();
static char *ptr;
static name_list **list;
static int cont = 0;
static int color;
int mods = 0;
unsigned int mods_used = (ShiftMask | ControlMask | Mod1Mask);

extern int do_single_keyword(), do_string_keyword(), do_number_keyword();
extern name_list **do_colorlist_keyword();
extern int do_color_keyword(), do_string_savecolor();
extern int yylineno;

# line 107 "gram.y"
typedef union
#ifdef __cplusplus
	YYSTYPE
#endif

{
    int num;
    char *ptr;
} YYSTYPE;
# define LB 257
# define RB 258
# define LP 259
# define RP 260
# define MENUS 261
# define MENU 262
# define BUTTON 263
# define DEFAULT_FUNCTION 264
# define PLUS 265
# define MINUS 266
# define ALL 267
# define OR 268
# define CURSORS 269
# define PIXMAPS 270
# define ICONS 271
# define COLOR 272
# define SAVECOLOR 273
# define MONOCHROME 274
# define FUNCTION 275
# define ICONMGR_SHOW 276
# define ICONMGR 277
# define ALTER 278
# define WINDOW_FUNCTION 279
# define ZOOM 280
# define ICONMGRS 281
# define ICONMGR_GEOMETRY 282
# define ICONMGR_NOSHOW 283
# define MAKE_TITLE 284
# define ICONIFY_BY_UNMAPPING 285
# define DONT_ICONIFY_BY_UNMAPPING 286
# define NO_BORDER 287
# define NO_ICON_TITLE 288
# define NO_TITLE 289
# define AUTO_RAISE 290
# define NO_HILITE 291
# define ICON_REGION 292
# define WINDOW_REGION 293
# define META 294
# define SHIFT 295
# define LOCK 296
# define CONTROL 297
# define WINDOW 298
# define TITLE 299
# define ICON 300
# define ROOT 301
# define FRAME 302
# define COLON 303
# define EQUALS 304
# define SQUEEZE_TITLE 305
# define DONT_SQUEEZE_TITLE 306
# define START_ICONIFIED 307
# define NO_TITLE_HILITE 308
# define TITLE_HILITE 309
# define MOVE 310
# define RESIZE 311
# define WAITC 312
# define SELECT 313
# define KILL 314
# define LEFT_TITLEBUTTON 315
# define RIGHT_TITLEBUTTON 316
# define NUMBER 317
# define KEYWORD 318
# define NKEYWORD 319
# define CKEYWORD 320
# define CLKEYWORD 321
# define FKEYWORD 322
# define FSKEYWORD 323
# define SKEYWORD 324
# define DKEYWORD 325
# define JKEYWORD 326
# define WINDOW_RING 327
# define WARP_CURSOR 328
# define ERRORTOKEN 329
# define NO_STACKMODE 330
# define ALWAYS_ON_TOP 331
# define WORKSPACE 332
# define WORKSPACES 333
# define WORKSPCMGR_GEOMETRY 334
# define OCCUPYALL 335
# define OCCUPYLIST 336
# define MAPWINDOWCURRENTWORKSPACE 337
# define MAPWINDOWDEFAULTWORKSPACE 338
# define OPAQUEMOVE 339
# define NOOPAQUEMOVE 340
# define OPAQUERESIZE 341
# define NOOPAQUERESIZE 342
# define CHANGE_WORKSPACE_FUNCTION 343
# define DEICONIFY_FUNCTION 344
# define ICONIFY_FUNCTION 345
# define STRING 346

#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#else
#include <malloc.h>
#include <memory.h>
#endif

#include <values.h>

#ifdef __cplusplus

#ifndef yyerror
	void yyerror(const char *);
#endif

#ifndef yylex
#ifdef __EXTERN_C__
	extern "C" { int yylex(void); }
#else
	int yylex(void);
#endif
#endif
	int yyparse(void);

#endif
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256

# line 912 "gram.y"

yyerror(s) char *s;
{
    twmrc_error_prefix();
    fprintf (stderr, "error in input file:  %s\n", s ? s : "");
    ParseError = 1;
}
RemoveDQuote(str)
char *str;
{
    register char *i, *o;
    register n;
    register count;

    for (i=str+1, o=str; *i && *i != '\"'; o++)
    {
	if (*i == '\\')
	{
	    switch (*++i)
	    {
	    case 'n':
		*o = '\n';
		i++;
		break;
	    case 'b':
		*o = '\b';
		i++;
		break;
	    case 'r':
		*o = '\r';
		i++;
		break;
	    case 't':
		*o = '\t';
		i++;
		break;
	    case 'f':
		*o = '\f';
		i++;
		break;
	    case '0':
		if (*++i == 'x')
		    goto hex;
		else
		    --i;
	    case '1': case '2': case '3':
	    case '4': case '5': case '6': case '7':
		n = 0;
		count = 0;
		while (*i >= '0' && *i <= '7' && count < 3)
		{
		    n = (n<<3) + (*i++ - '0');
		    count++;
		}
		*o = n;
		break;
	    hex:
	    case 'x':
		n = 0;
		count = 0;
		while (i++, count++ < 2)
		{
		    if (*i >= '0' && *i <= '9')
			n = (n<<4) + (*i - '0');
		    else if (*i >= 'a' && *i <= 'f')
			n = (n<<4) + (*i - 'a') + 10;
		    else if (*i >= 'A' && *i <= 'F')
			n = (n<<4) + (*i - 'A') + 10;
		    else
			break;
		}
		*o = n;
		break;
	    case '\n':
		i++;	/* punt */
		o--;	/* to account for o++ at end of loop */
		break;
	    case '\"':
	    case '\'':
	    case '\\':
	    default:
		*o = *i++;
		break;
	    }
	}
	else
	    *o = *i++;
    }
    *o = '\0';
}

static MenuRoot *GetRoot(name, fore, back)
char *name;
char *fore, *back;
{
    MenuRoot *tmp;

    tmp = FindMenuRoot(name);
    if (tmp == NULL)
	tmp = NewMenuRoot(name);

    if (fore)
    {
	int save;

	save = Scr->FirstTime;
	Scr->FirstTime = TRUE;
	GetColor(COLOR, &tmp->highlight.fore, fore);
	GetColor(COLOR, &tmp->highlight.back, back);
	Scr->FirstTime = save;
    }

    return tmp;
}

static void GotButton (butt, func)
int butt, func;
{
    int i;
    MenuItem *item;

    for (i = 0; i < NUM_CONTEXTS; i++) {
	if ((cont & (1 << i)) == 0) continue;

	if (func == F_MENU) {
	    pull->prev = NULL;
	    AddFuncButton (butt, i, mods, func, pull, (MenuItem*) 0);
	}
	else {
	    root = GetRoot (TWM_ROOT, NULLSTR, NULLSTR);
	    item = AddToMenu (root, "x", Action, NULLSTR, func, NULLSTR, NULLSTR);
	    AddFuncButton (butt, i, mods, func, (MenuRoot*) 0, item);
	}
    }

    Action = "";
    pull = NULL;
    cont = 0;
    mods_used |= mods;
    mods = 0;
}

static void GotKey(key, func)
char *key;
int func;
{
    int i;

    for (i = 0; i < NUM_CONTEXTS; i++)
    {
	if ((cont & (1 << i)) == 0) 
	  continue;

	if (func == F_MENU) {
	    pull->prev = NULL;
	    if (!AddFuncKey (key, i, mods, func, pull, Name, Action)) break;
	}
	else
	if (!AddFuncKey(key, i, mods, func, (MenuRoot*) 0, Name, Action)) 
	  break;
    }

    Action = "";
    pull = NULL;
    cont = 0;
    mods_used |= mods;
    mods = 0;
}


static void GotTitleButton (bitmapname, func, rightside)
    char *bitmapname;
    int func;
    Bool rightside;
{
    if (!CreateTitleButton (bitmapname, func, Action, pull, rightside, True)) {
	twmrc_error_prefix();
	fprintf (stderr, 
		 "unable to create %s titlebutton \"%s\"\n",
		 rightside ? "right" : "left", bitmapname);
    }
    Action = "";
    pull = NULL;
}

static Bool CheckWarpScreenArg (s)
    register char *s;
{
    XmuCopyISOLatin1Lowered (s, s);

    if (strcmp (s,  WARPSCREEN_NEXT) == 0 ||
	strcmp (s,  WARPSCREEN_PREV) == 0 ||
	strcmp (s,  WARPSCREEN_BACK) == 0)
      return True;

    for (; *s && isascii(*s) && isdigit(*s); s++) ; /* SUPPRESS 530 */
    return (*s ? False : True);
}


static Bool CheckWarpRingArg (s)
    register char *s;
{
    XmuCopyISOLatin1Lowered (s, s);

    if (strcmp (s,  WARPSCREEN_NEXT) == 0 ||
	strcmp (s,  WARPSCREEN_PREV) == 0)
      return True;

    return False;
}


static Bool CheckColormapArg (s)
    register char *s;
{
    XmuCopyISOLatin1Lowered (s, s);

    if (strcmp (s, COLORMAP_NEXT) == 0 ||
	strcmp (s, COLORMAP_PREV) == 0 ||
	strcmp (s, COLORMAP_DEFAULT) == 0)
      return True;

    return False;
}


twmrc_error_prefix ()
{
    fprintf (stderr, "%s:  line %d:  ", ProgramName, yylineno);
}
yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 2,
	0, 1,
	-2, 0,
-1, 18,
	257, 35,
	-2, 37,
-1, 19,
	257, 38,
	-2, 40,
-1, 20,
	257, 41,
	-2, 43,
-1, 21,
	257, 44,
	-2, 46,
-1, 22,
	257, 47,
	-2, 49,
-1, 31,
	257, 68,
	-2, 70,
-1, 34,
	257, 75,
	-2, 77,
-1, 35,
	257, 78,
	-2, 80,
-1, 37,
	257, 83,
	-2, 85,
-1, 39,
	257, 88,
	-2, 90,
-1, 40,
	257, 91,
	-2, 93,
-1, 43,
	257, 98,
	-2, 100,
-1, 55,
	257, 120,
	-2, 122,
-1, 56,
	257, 123,
	-2, 125,
-1, 60,
	257, 216,
	-2, 215,
-1, 61,
	257, 219,
	-2, 218,
-1, 258,
	257, 232,
	-2, 231,
-1, 283,
	257, 13,
	-2, 9,
-1, 341,
	257, 203,
	-2, 202,
-1, 344,
	257, 15,
	-2, 10,
-1, 369,
	257, 17,
	-2, 11,
-1, 388,
	257, 19,
	-2, 12,
	};
# define YYNPROD 292
# define YYLAST 664
yytabelem yyact[]={

    26,   136,   222,   259,   277,   355,   324,   326,   408,    84,
    64,    65,    66,    67,    63,    71,   322,   325,   343,   184,
   363,   183,   404,   394,    81,    82,    83,   391,   348,    88,
   346,   334,   287,   323,   127,   285,   281,   317,   318,   319,
   320,   321,   315,   262,    63,   108,   109,    86,    87,   270,
   264,   256,   248,   234,   232,   126,    86,    87,    71,   121,
   114,   115,   116,   117,   118,   337,   187,   280,   137,   413,
   144,    63,   142,   273,   399,   367,   368,   263,   350,   138,
   139,   140,   141,    86,    87,    63,    90,   267,   146,   300,
   361,    63,    63,   149,    62,   152,    63,   155,   169,   158,
   159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
    63,    63,   373,   372,   223,    63,    63,   189,    63,    63,
    63,   179,   180,    63,    63,   384,   182,    71,   379,    86,
    87,   356,   185,   216,   186,   276,   275,    63,    63,    63,
    63,    63,    63,   215,   354,   313,   314,   225,   206,   181,
   175,   177,   204,   173,   207,   310,   312,   157,   154,   211,
   212,   213,   214,   151,   133,   131,    75,    73,   217,    25,
   221,   205,   311,   335,   174,   147,   305,   306,   307,   308,
   309,   303,   216,   268,   338,   269,   233,   235,   271,   226,
   236,   405,   215,   237,   238,   239,   240,   241,   242,   243,
   244,   245,   246,   247,   250,   397,   395,   376,   211,   212,
   213,   214,   378,   358,   357,   329,   260,   209,   219,   258,
   261,   266,   249,   203,   392,   375,   353,   272,   328,   279,
   282,   257,   218,   284,   286,   265,   288,   220,   289,   290,
   291,   292,   293,   294,   295,   296,   297,   298,   299,   124,
   229,   123,   409,   400,   278,   190,   327,   228,   383,   200,
   196,   364,   274,   330,   331,   227,   148,   332,   333,   336,
   191,   135,   188,   340,   195,   134,   341,   342,   301,   339,
   251,   316,   304,   210,   344,   255,   252,   347,   178,   349,
   120,   119,   113,   176,    70,   112,   193,   194,   111,   192,
   172,   110,   224,   171,   170,   381,   107,   197,   198,   199,
   201,   202,   106,   351,   105,   104,   103,   208,   102,   101,
   100,    99,    98,    97,   156,   352,    96,    95,   153,    94,
    93,   150,    92,   360,    91,   145,   143,    80,    79,    78,
    77,    76,    74,    72,   132,   369,   362,   371,    69,   130,
    68,   231,   401,   389,   122,   370,   345,   125,     8,     7,
   374,   128,   129,   377,   382,     6,     5,     3,     2,     1,
   388,    89,   390,    85,   365,     0,   393,   396,     0,     0,
     0,     0,     0,     0,   398,     0,     0,     0,     0,     0,
     0,   402,     0,     0,   403,     0,     0,     0,   406,     0,
   407,   410,     0,   411,   412,     0,     0,     0,     0,     0,
     0,   414,     4,   415,     0,     0,   417,     0,    44,    62,
    50,   302,     0,   416,     0,    17,    16,    46,    47,    48,
    49,    45,    33,     0,     0,    51,    15,    32,    11,    31,
    41,    18,    27,    38,    39,    40,    43,    35,     9,    10,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    60,    61,    42,    34,     0,     0,     0,     0,     0,
     0,    23,    24,     0,    57,    59,     0,     0,   230,     0,
    58,     0,     0,    56,    55,     0,    37,    36,     0,    28,
    12,    29,    30,    13,    14,    19,    20,    21,    22,    52,
    53,    54,    63,     0,     0,     0,   253,     0,     0,     0,
   254,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   283,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   359,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   366,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   380,     0,     0,     0,     0,
   385,     0,   386,   387 };
yytabelem yypact[]={

-10000000,-10000000,   156,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,  -332,
  -332,  -332,  -332,-10000000,-10000000,  -259,   -90,   -91,-10000000,-10000000,
-10000000,-10000000,-10000000,  -332,  -332,  -275,  -218,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,  -332,  -332,-10000000,-10000000,-10000000,-10000000,
  -266,  -266,  -266,  -266,  -266,-10000000,-10000000,-10000000,  -332,  -259,
-10000000,-10000000,  -259,-10000000,  -270,  -291,  -259,  -259,   -92,   -93,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,  -189,  -189,  -189,  -189,
  -189,  -232,  -234,-10000000,-10000000,-10000000,-10000000,  -332,-10000000,-10000000,
-10000000,  -189,   -94,  -189,   -99,  -189,  -100,  -189,  -189,  -189,
  -189,  -189,  -189,  -189,  -189,  -189,  -189,  -189,  -161,-10000000,
  -104,  -107,  -106,  -107,-10000000,-10000000,-10000000,-10000000,-10000000,  -189,
  -189,-10000000,-10000000,  -108,  -189,-10000000,  -304,  -306,-10000000,-10000000,
-10000000,  -332,-10000000,  -332,  -192,    -3,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,  -266,  -109,  -266,  -109,-10000000,   -86,  -135,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,  -332,
  -143,  -110,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,  -259,-10000000,  -204,  -205,-10000000,-10000000,  -332,
-10000000,-10000000,  -332,  -332,  -332,  -332,  -332,  -332,  -332,  -332,
  -332,  -332,  -332,  -206,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,  -259,-10000000,-10000000,-10000000,  -259,-10000000,-10000000,  -207,  -255,
  -208,  -216,-10000000,-10000000,-10000000,-10000000,  -209,  -185,  -254,  -222,
  -259,  -189,-10000000,  -223,-10000000,  -226,-10000000,  -332,  -332,  -332,
  -332,  -332,  -332,  -332,  -332,  -332,  -332,  -332,-10000000,-10000000,
-10000000,  -169,  -122,-10000000,-10000000,  -261,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,  -332,  -332,-10000000,-10000000,  -332,  -332,  -227,  -193,
-10000000,-10000000,  -332,-10000000,-10000000,  -332,  -332,-10000000,-10000000,-10000000,
-10000000,-10000000,  -308,  -332,-10000000,-10000000,  -228,-10000000,  -230,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,  -225,  -266,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,  -266,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,  -113,  -126,
-10000000,-10000000,  -302,  -170,-10000000,-10000000,  -239,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,  -190,  -332,  -189,-10000000,  -145,-10000000,  -146,
  -266,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,  -126,  -129,-10000000,
  -259,-10000000,-10000000,  -332,  -132,  -259,-10000000,  -259,  -259,  -332,
  -189,-10000000,-10000000,-10000000,-10000000,  -231,  -235,-10000000,-10000000,-10000000,
-10000000,  -143,  -229,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,  -189,
-10000000,-10000000,-10000000,  -332,-10000000,-10000000,-10000000,  -236,-10000000,  -332,
  -250,  -189,-10000000,  -332,-10000000,-10000000,-10000000,  -191,-10000000,-10000000,
  -332,-10000000,  -332,  -266,-10000000,  -332,-10000000,-10000000 };
yytabelem yypgo[]={

     0,     0,     9,   169,   294,   374,   373,   371,   369,   368,
   367,   366,   365,   359,   358,   356,     1,   355,   353,   352,
   351,   350,   349,   348,   344,   343,   342,   341,   340,   339,
   338,   337,   336,   171,   335,   334,   332,   331,   330,   329,
   328,   327,   326,   324,   323,   322,   321,   320,   319,   318,
   316,   315,   314,   312,   306,   305,     2,   304,   303,   302,
   301,   300,   298,   174,   295,   293,   292,   291,   290,   175,
   286,   285,   283,   282,   281,   280,   278,   275,   272,   271,
   270,   265,   262,   261,   258,   257,   254,   253,   252,   251,
   250,   249,   237,   235,   232,   231,   228,   226,   225,   224,
   223,   222,   218,   216,   215,     5,   214,   213,   212,   207,
   206,   205,   191,   189,   188,   185,   184,   183,   173 };
yytabelem yyr1[]={

     0,     8,     9,     9,    10,    10,    10,    10,    10,    10,
    10,    10,    10,    15,    10,    17,    10,    18,    10,    19,
    10,    20,    10,    10,    10,    10,    10,    21,    10,    23,
    10,    10,    10,    10,    10,    27,    10,    10,    28,    10,
    10,    29,    10,    10,    30,    10,    10,    31,    10,    10,
    10,    10,    32,    10,    34,    10,    10,    10,    10,    10,
    35,    10,    36,    10,    38,    10,    39,    10,    41,    10,
    10,    42,    10,    44,    10,    45,    10,    10,    46,    10,
    10,    47,    10,    48,    10,    10,    49,    10,    50,    10,
    10,    51,    10,    10,    52,    10,    53,    10,    54,    10,
    10,    55,    10,    57,    10,    58,    10,    60,    10,    62,
    10,    64,    10,    66,    10,    10,    10,    10,    10,    10,
    67,    10,    10,    68,    10,    10,    11,    12,    12,    13,
     6,     7,    69,    69,    72,    72,    72,    72,    72,    72,
    72,    70,    70,    73,    73,    73,    73,    73,    73,    73,
    73,    73,    73,    71,    71,    74,    74,    74,    74,    74,
    74,    74,    74,    74,    74,    74,    33,    75,    75,    76,
    25,    77,    77,    78,    26,    79,    79,    80,    80,    80,
    80,    80,    80,    80,    80,    80,    80,    80,    80,    80,
    80,    80,    80,    80,    80,    80,    80,    80,    80,    63,
    81,    81,    82,    83,    82,    82,    65,    85,    85,    86,
    86,    84,    87,    87,    88,    14,    89,    14,    14,    91,
    14,    90,    90,    43,    92,    92,    93,    93,    37,    94,
    94,    95,    96,    95,    97,    98,    98,    99,    99,    99,
    99,    99,    22,    22,    22,    22,    24,    24,    24,    24,
    16,   100,   100,   101,    40,   102,   102,   104,   103,   106,
   103,   107,   103,   105,   109,   109,   110,   108,   111,   111,
   112,    61,   113,   113,   114,    59,   115,   115,   116,    56,
   117,   117,   118,   118,     2,     2,     5,     5,     5,     3,
     1,     4 };
yytabelem yyr2[]={

     0,     2,     0,     4,     2,     2,     2,     2,     2,    13,
    15,    17,    19,     1,    16,     1,    18,     1,    20,     1,
    22,     1,    12,     7,     5,     7,     5,     1,     6,     1,
     6,     5,     3,     5,     5,     1,     6,     3,     1,     6,
     3,     1,     6,     3,     1,     6,     3,     1,     6,     3,
     9,     9,     1,     8,     1,     8,     5,     5,     5,     5,
     1,     6,     1,     6,     1,     6,     1,     6,     1,     6,
     3,     1,     6,     1,     6,     1,     6,     3,     1,     6,
     3,     1,     6,     1,     6,     3,     1,     6,     1,     6,
     3,     1,     6,     3,     1,     6,     1,     6,     1,     6,
     3,     1,    19,     1,     9,     1,     8,     1,     6,     1,
     6,     1,     6,     1,     6,     5,     5,     5,     5,     5,
     1,     6,     3,     1,     6,     3,     3,     5,     3,     5,
    13,    13,     0,     4,     3,     3,     3,     3,     5,     5,
     3,     0,     4,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     0,     4,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     7,     0,     4,     7,
     7,     0,     4,     5,     7,     0,     4,     7,     5,     7,
     5,     7,     5,     7,     5,     7,     5,     7,     5,     7,
     5,     7,     5,     7,     5,     7,     5,     7,     5,     7,
     0,     4,     5,     1,     8,     5,     7,     0,     4,     3,
     3,     7,     0,     4,     5,     3,     1,    10,     3,     1,
     6,     0,    11,     7,     0,     4,     7,     9,     7,     0,
     4,     3,     1,     6,     7,     0,     4,     3,     5,     7,
     9,    11,     7,     9,    11,    13,     7,     9,    11,    13,
     7,     0,     4,     3,     7,     0,     4,     1,     6,     1,
     8,     1,     8,     7,     0,     4,     3,     7,     0,     4,
     3,     7,     0,     4,     5,     7,     0,     4,     3,     7,
     0,     4,     5,    15,     3,     5,     3,     5,     5,     5,
     3,     3 };
yytabelem yychk[]={

-10000000,    -8,    -9,   -10,   256,   -11,   -12,   -13,   -14,   292,
   293,   282,   334,   337,   338,   280,   270,   269,   285,   339,
   340,   341,   342,   315,   316,    -3,    -1,   286,   333,   335,
   336,   283,   281,   276,   308,   291,   331,   330,   287,   288,
   289,   284,   307,   290,   262,   275,   271,   272,   273,   274,
   264,   279,   343,   344,   345,   328,   327,   318,   324,   319,
   305,   306,   263,   346,    -1,    -1,    -1,    -1,   -21,   -23,
    -4,   317,   -25,   257,   -26,   257,   -27,   -28,   -29,   -30,
   -31,    -1,    -1,    -1,    -2,    -6,   322,   323,   304,    -7,
   304,   -35,   -36,   -38,   -39,   -41,   -42,   -44,   -45,   -46,
   -47,   -48,   -49,   -50,   -51,   -52,   -53,   -54,    -1,    -1,
   -60,   -62,   -64,   -66,    -2,    -2,    -2,    -2,    -2,   -67,
   -68,    -1,    -4,   -89,   -91,    -4,   325,   325,    -4,    -4,
   -22,   257,   -24,   257,   -77,   -79,   -16,   257,   -16,   -16,
   -16,   -16,   304,   -32,   304,   -34,    -1,   -69,   -69,   -16,
   -37,   257,   -16,   -40,   257,   -16,   -43,   257,   -16,   -16,
   -16,   -16,   -16,   -16,   -16,   -16,   -16,   -16,   -16,   259,
   -57,   -58,   -61,   257,   -63,   257,   -65,   257,   -63,   -16,
   -16,   257,   -16,   325,   325,    -1,    -1,   258,   -78,   309,
   258,   -80,   302,   299,   300,   277,   263,   310,   311,   312,
   262,   313,   314,  -100,    -2,   -33,   257,    -2,   -33,   303,
   -72,   294,   295,   296,   297,   278,   268,   303,   -94,  -102,
   -92,    -1,   -56,   257,   -59,   257,  -113,   -81,   -85,   -90,
    -4,   -20,   258,    -1,   258,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   258,  -101,
    -1,   -75,   -70,    -4,    -4,   -71,   258,   -95,    -1,   258,
  -103,    -1,   298,   332,   258,   -93,    -1,   303,  -117,  -115,
   258,  -114,    -1,   258,   -82,   321,   320,   258,   -86,    -1,
   321,   258,    -1,    -4,   -16,   258,    -1,   258,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
   258,   -76,    -3,   303,   -73,   298,   299,   300,   301,   302,
   277,   294,   278,   267,   268,   303,   -74,   298,   299,   300,
   301,   302,   277,   294,   267,   278,   268,    -1,   -96,  -104,
    -1,    -1,    -1,    -1,   258,  -118,    -1,   258,  -116,    -2,
    -1,    -1,    -1,   326,    -1,   -15,   258,    -1,   258,    -1,
   303,    -2,    -2,   -97,   257,  -105,   257,  -106,  -107,    -4,
    -1,   260,    -2,   259,   -83,    -5,    -4,   265,   266,    -1,
   -17,   -16,   258,   258,    -2,   -98,  -109,  -105,  -108,   257,
    -4,   -55,    -1,   -84,   257,    -4,    -4,    -4,    -1,   -18,
   -16,   258,   -99,    -1,   258,  -110,    -1,  -111,   -56,   303,
   -87,   -19,   -16,    -1,   258,  -112,    -1,    -1,   258,   -88,
    -1,   -16,    -1,   260,    -1,    -1,    -2,    -1 };
yytabelem yydef[]={

     2,    -2,    -2,     3,     4,     5,     6,     7,     8,     0,
     0,     0,     0,    27,    29,    32,     0,     0,    -2,    -2,
    -2,    -2,    -2,     0,     0,     0,     0,    60,    62,    64,
    66,    -2,    71,    73,    -2,    -2,    81,    -2,    86,    -2,
    -2,    94,    96,    -2,     0,     0,   107,   109,   111,   113,
     0,     0,     0,     0,     0,    -2,    -2,   126,   128,     0,
    -2,    -2,     0,   290,     0,     0,    24,    26,     0,     0,
    31,   291,    33,   171,    34,   175,     0,     0,     0,     0,
     0,    52,    54,    56,    57,    59,   284,     0,   132,    58,
   132,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   103,   105,
     0,     0,     0,     0,   115,   116,   117,   118,   119,     0,
     0,   127,   129,     0,     0,   289,     0,     0,    23,    25,
    28,     0,    30,     0,     0,     0,    36,   251,    39,    42,
    45,    48,     0,     0,     0,     0,   285,     0,     0,    61,
    63,   229,    65,    67,   255,    69,    72,   224,    74,    76,
    79,    82,    84,    87,    89,    92,    95,    97,    99,     0,
     0,     0,   108,   272,   110,   200,   112,   207,   114,   121,
   124,   221,   220,     0,    21,     0,     0,   170,   172,     0,
   174,   176,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    50,    53,   167,    51,    55,   141,
   133,   134,   135,   136,   137,     0,   140,   153,     0,     0,
     0,     0,   104,   280,   106,   276,     0,     0,     0,     0,
     0,     0,   242,     0,   246,     0,   173,   178,   180,   182,
   184,   186,   188,   190,   192,   194,   196,   198,   250,   252,
   253,     0,     0,   139,   138,     0,   228,   230,    -2,   254,
   256,   257,     0,     0,   223,   225,     0,     0,     0,     0,
   271,   273,     0,   199,   201,     0,     0,   206,   208,   209,
   210,   217,     0,    -2,    22,   243,     0,   247,     0,   177,
   179,   181,   183,   185,   187,   189,   191,   193,   195,   197,
   166,   168,     0,     0,   142,   143,   144,   145,   146,   147,
   148,   149,   150,   151,   152,     0,   154,   155,   156,   157,
   158,   159,   160,   161,   162,   163,   164,   165,     0,     0,
   259,   261,     0,     0,   279,   281,     0,   275,   277,   278,
   274,    -2,   205,     0,    -2,     0,   244,     0,   248,     0,
     0,   130,   131,   233,   235,   258,   264,     0,     0,   226,
     0,   101,   282,     0,     0,     0,   286,     0,     0,    -2,
     0,    14,   245,   249,   169,     0,     0,   260,   262,   268,
   227,     0,     0,   204,   212,   222,   287,   288,    -2,     0,
    16,   234,   236,   237,   263,   265,   266,     0,   102,     0,
     0,     0,    18,   238,   267,   269,   270,     0,   211,   213,
     0,    20,   239,     0,   214,   240,   283,   241 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{ char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"LB",	257,
	"RB",	258,
	"LP",	259,
	"RP",	260,
	"MENUS",	261,
	"MENU",	262,
	"BUTTON",	263,
	"DEFAULT_FUNCTION",	264,
	"PLUS",	265,
	"MINUS",	266,
	"ALL",	267,
	"OR",	268,
	"CURSORS",	269,
	"PIXMAPS",	270,
	"ICONS",	271,
	"COLOR",	272,
	"SAVECOLOR",	273,
	"MONOCHROME",	274,
	"FUNCTION",	275,
	"ICONMGR_SHOW",	276,
	"ICONMGR",	277,
	"ALTER",	278,
	"WINDOW_FUNCTION",	279,
	"ZOOM",	280,
	"ICONMGRS",	281,
	"ICONMGR_GEOMETRY",	282,
	"ICONMGR_NOSHOW",	283,
	"MAKE_TITLE",	284,
	"ICONIFY_BY_UNMAPPING",	285,
	"DONT_ICONIFY_BY_UNMAPPING",	286,
	"NO_BORDER",	287,
	"NO_ICON_TITLE",	288,
	"NO_TITLE",	289,
	"AUTO_RAISE",	290,
	"NO_HILITE",	291,
	"ICON_REGION",	292,
	"WINDOW_REGION",	293,
	"META",	294,
	"SHIFT",	295,
	"LOCK",	296,
	"CONTROL",	297,
	"WINDOW",	298,
	"TITLE",	299,
	"ICON",	300,
	"ROOT",	301,
	"FRAME",	302,
	"COLON",	303,
	"EQUALS",	304,
	"SQUEEZE_TITLE",	305,
	"DONT_SQUEEZE_TITLE",	306,
	"START_ICONIFIED",	307,
	"NO_TITLE_HILITE",	308,
	"TITLE_HILITE",	309,
	"MOVE",	310,
	"RESIZE",	311,
	"WAITC",	312,
	"SELECT",	313,
	"KILL",	314,
	"LEFT_TITLEBUTTON",	315,
	"RIGHT_TITLEBUTTON",	316,
	"NUMBER",	317,
	"KEYWORD",	318,
	"NKEYWORD",	319,
	"CKEYWORD",	320,
	"CLKEYWORD",	321,
	"FKEYWORD",	322,
	"FSKEYWORD",	323,
	"SKEYWORD",	324,
	"DKEYWORD",	325,
	"JKEYWORD",	326,
	"WINDOW_RING",	327,
	"WARP_CURSOR",	328,
	"ERRORTOKEN",	329,
	"NO_STACKMODE",	330,
	"ALWAYS_ON_TOP",	331,
	"WORKSPACE",	332,
	"WORKSPACES",	333,
	"WORKSPCMGR_GEOMETRY",	334,
	"OCCUPYALL",	335,
	"OCCUPYLIST",	336,
	"MAPWINDOWCURRENTWORKSPACE",	337,
	"MAPWINDOWDEFAULTWORKSPACE",	338,
	"OPAQUEMOVE",	339,
	"NOOPAQUEMOVE",	340,
	"OPAQUERESIZE",	341,
	"NOOPAQUERESIZE",	342,
	"CHANGE_WORKSPACE_FUNCTION",	343,
	"DEICONIFY_FUNCTION",	344,
	"ICONIFY_FUNCTION",	345,
	"STRING",	346,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"twmrc : stmts",
	"stmts : /* empty */",
	"stmts : stmts stmt",
	"stmt : error",
	"stmt : noarg",
	"stmt : sarg",
	"stmt : narg",
	"stmt : squeeze",
	"stmt : ICON_REGION string DKEYWORD DKEYWORD number number",
	"stmt : ICON_REGION string DKEYWORD DKEYWORD number number string",
	"stmt : ICON_REGION string DKEYWORD DKEYWORD number number string string",
	"stmt : ICON_REGION string DKEYWORD DKEYWORD number number string string string",
	"stmt : ICON_REGION string DKEYWORD DKEYWORD number number",
	"stmt : ICON_REGION string DKEYWORD DKEYWORD number number win_list",
	"stmt : ICON_REGION string DKEYWORD DKEYWORD number number string",
	"stmt : ICON_REGION string DKEYWORD DKEYWORD number number string win_list",
	"stmt : ICON_REGION string DKEYWORD DKEYWORD number number string string",
	"stmt : ICON_REGION string DKEYWORD DKEYWORD number number string string win_list",
	"stmt : ICON_REGION string DKEYWORD DKEYWORD number number string string string",
	"stmt : ICON_REGION string DKEYWORD DKEYWORD number number string string string win_list",
	"stmt : WINDOW_REGION string DKEYWORD DKEYWORD",
	"stmt : WINDOW_REGION string DKEYWORD DKEYWORD win_list",
	"stmt : ICONMGR_GEOMETRY string number",
	"stmt : ICONMGR_GEOMETRY string",
	"stmt : WORKSPCMGR_GEOMETRY string number",
	"stmt : WORKSPCMGR_GEOMETRY string",
	"stmt : MAPWINDOWCURRENTWORKSPACE",
	"stmt : MAPWINDOWCURRENTWORKSPACE curwork",
	"stmt : MAPWINDOWDEFAULTWORKSPACE",
	"stmt : MAPWINDOWDEFAULTWORKSPACE defwork",
	"stmt : ZOOM number",
	"stmt : ZOOM",
	"stmt : PIXMAPS pixmap_list",
	"stmt : CURSORS cursor_list",
	"stmt : ICONIFY_BY_UNMAPPING",
	"stmt : ICONIFY_BY_UNMAPPING win_list",
	"stmt : ICONIFY_BY_UNMAPPING",
	"stmt : OPAQUEMOVE",
	"stmt : OPAQUEMOVE win_list",
	"stmt : OPAQUEMOVE",
	"stmt : NOOPAQUEMOVE",
	"stmt : NOOPAQUEMOVE win_list",
	"stmt : NOOPAQUEMOVE",
	"stmt : OPAQUERESIZE",
	"stmt : OPAQUERESIZE win_list",
	"stmt : OPAQUERESIZE",
	"stmt : NOOPAQUERESIZE",
	"stmt : NOOPAQUERESIZE win_list",
	"stmt : NOOPAQUERESIZE",
	"stmt : LEFT_TITLEBUTTON string EQUALS action",
	"stmt : RIGHT_TITLEBUTTON string EQUALS action",
	"stmt : LEFT_TITLEBUTTON string",
	"stmt : LEFT_TITLEBUTTON string binding_list",
	"stmt : RIGHT_TITLEBUTTON string",
	"stmt : RIGHT_TITLEBUTTON string binding_list",
	"stmt : button string",
	"stmt : button action",
	"stmt : string fullkey",
	"stmt : button full",
	"stmt : DONT_ICONIFY_BY_UNMAPPING",
	"stmt : DONT_ICONIFY_BY_UNMAPPING win_list",
	"stmt : WORKSPACES",
	"stmt : WORKSPACES workspc_list",
	"stmt : OCCUPYALL",
	"stmt : OCCUPYALL win_list",
	"stmt : OCCUPYLIST",
	"stmt : OCCUPYLIST occupy_list",
	"stmt : ICONMGR_NOSHOW",
	"stmt : ICONMGR_NOSHOW win_list",
	"stmt : ICONMGR_NOSHOW",
	"stmt : ICONMGRS",
	"stmt : ICONMGRS iconm_list",
	"stmt : ICONMGR_SHOW",
	"stmt : ICONMGR_SHOW win_list",
	"stmt : NO_TITLE_HILITE",
	"stmt : NO_TITLE_HILITE win_list",
	"stmt : NO_TITLE_HILITE",
	"stmt : NO_HILITE",
	"stmt : NO_HILITE win_list",
	"stmt : NO_HILITE",
	"stmt : ALWAYS_ON_TOP",
	"stmt : ALWAYS_ON_TOP win_list",
	"stmt : NO_STACKMODE",
	"stmt : NO_STACKMODE win_list",
	"stmt : NO_STACKMODE",
	"stmt : NO_BORDER",
	"stmt : NO_BORDER win_list",
	"stmt : NO_ICON_TITLE",
	"stmt : NO_ICON_TITLE win_list",
	"stmt : NO_ICON_TITLE",
	"stmt : NO_TITLE",
	"stmt : NO_TITLE win_list",
	"stmt : NO_TITLE",
	"stmt : MAKE_TITLE",
	"stmt : MAKE_TITLE win_list",
	"stmt : START_ICONIFIED",
	"stmt : START_ICONIFIED win_list",
	"stmt : AUTO_RAISE",
	"stmt : AUTO_RAISE win_list",
	"stmt : AUTO_RAISE",
	"stmt : MENU string LP string COLON string RP",
	"stmt : MENU string LP string COLON string RP menu",
	"stmt : MENU string",
	"stmt : MENU string menu",
	"stmt : FUNCTION string",
	"stmt : FUNCTION string function",
	"stmt : ICONS",
	"stmt : ICONS icon_list",
	"stmt : COLOR",
	"stmt : COLOR color_list",
	"stmt : SAVECOLOR",
	"stmt : SAVECOLOR save_color_list",
	"stmt : MONOCHROME",
	"stmt : MONOCHROME color_list",
	"stmt : DEFAULT_FUNCTION action",
	"stmt : WINDOW_FUNCTION action",
	"stmt : CHANGE_WORKSPACE_FUNCTION action",
	"stmt : DEICONIFY_FUNCTION action",
	"stmt : ICONIFY_FUNCTION action",
	"stmt : WARP_CURSOR",
	"stmt : WARP_CURSOR win_list",
	"stmt : WARP_CURSOR",
	"stmt : WINDOW_RING",
	"stmt : WINDOW_RING win_list",
	"stmt : WINDOW_RING",
	"noarg : KEYWORD",
	"sarg : SKEYWORD string",
	"sarg : SKEYWORD",
	"narg : NKEYWORD number",
	"full : EQUALS keys COLON contexts COLON action",
	"fullkey : EQUALS keys COLON contextkeys COLON action",
	"keys : /* empty */",
	"keys : keys key",
	"key : META",
	"key : SHIFT",
	"key : LOCK",
	"key : CONTROL",
	"key : ALTER number",
	"key : META number",
	"key : OR",
	"contexts : /* empty */",
	"contexts : contexts context",
	"context : WINDOW",
	"context : TITLE",
	"context : ICON",
	"context : ROOT",
	"context : FRAME",
	"context : ICONMGR",
	"context : META",
	"context : ALTER",
	"context : ALL",
	"context : OR",
	"contextkeys : /* empty */",
	"contextkeys : contextkeys contextkey",
	"contextkey : WINDOW",
	"contextkey : TITLE",
	"contextkey : ICON",
	"contextkey : ROOT",
	"contextkey : FRAME",
	"contextkey : ICONMGR",
	"contextkey : META",
	"contextkey : ALL",
	"contextkey : ALTER",
	"contextkey : OR",
	"contextkey : string",
	"binding_list : LB binding_entries RB",
	"binding_entries : /* empty */",
	"binding_entries : binding_entries binding_entry",
	"binding_entry : button COLON action",
	"pixmap_list : LB pixmap_entries RB",
	"pixmap_entries : /* empty */",
	"pixmap_entries : pixmap_entries pixmap_entry",
	"pixmap_entry : TITLE_HILITE string",
	"cursor_list : LB cursor_entries RB",
	"cursor_entries : /* empty */",
	"cursor_entries : cursor_entries cursor_entry",
	"cursor_entry : FRAME string string",
	"cursor_entry : FRAME string",
	"cursor_entry : TITLE string string",
	"cursor_entry : TITLE string",
	"cursor_entry : ICON string string",
	"cursor_entry : ICON string",
	"cursor_entry : ICONMGR string string",
	"cursor_entry : ICONMGR string",
	"cursor_entry : BUTTON string string",
	"cursor_entry : BUTTON string",
	"cursor_entry : MOVE string string",
	"cursor_entry : MOVE string",
	"cursor_entry : RESIZE string string",
	"cursor_entry : RESIZE string",
	"cursor_entry : WAITC string string",
	"cursor_entry : WAITC string",
	"cursor_entry : MENU string string",
	"cursor_entry : MENU string",
	"cursor_entry : SELECT string string",
	"cursor_entry : SELECT string",
	"cursor_entry : KILL string string",
	"cursor_entry : KILL string",
	"color_list : LB color_entries RB",
	"color_entries : /* empty */",
	"color_entries : color_entries color_entry",
	"color_entry : CLKEYWORD string",
	"color_entry : CLKEYWORD string",
	"color_entry : CLKEYWORD string win_color_list",
	"color_entry : CKEYWORD string",
	"save_color_list : LB s_color_entries RB",
	"s_color_entries : /* empty */",
	"s_color_entries : s_color_entries s_color_entry",
	"s_color_entry : string",
	"s_color_entry : CLKEYWORD",
	"win_color_list : LB win_color_entries RB",
	"win_color_entries : /* empty */",
	"win_color_entries : win_color_entries win_color_entry",
	"win_color_entry : string string",
	"squeeze : SQUEEZE_TITLE",
	"squeeze : SQUEEZE_TITLE",
	"squeeze : SQUEEZE_TITLE LB win_sqz_entries RB",
	"squeeze : DONT_SQUEEZE_TITLE",
	"squeeze : DONT_SQUEEZE_TITLE",
	"squeeze : DONT_SQUEEZE_TITLE win_list",
	"win_sqz_entries : /* empty */",
	"win_sqz_entries : win_sqz_entries string JKEYWORD signed_number number",
	"iconm_list : LB iconm_entries RB",
	"iconm_entries : /* empty */",
	"iconm_entries : iconm_entries iconm_entry",
	"iconm_entry : string string number",
	"iconm_entry : string string string number",
	"workspc_list : LB workspc_entries RB",
	"workspc_entries : /* empty */",
	"workspc_entries : workspc_entries workspc_entry",
	"workspc_entry : string",
	"workspc_entry : string",
	"workspc_entry : string workapp_list",
	"workapp_list : LB workapp_entries RB",
	"workapp_entries : /* empty */",
	"workapp_entries : workapp_entries workapp_entry",
	"workapp_entry : string",
	"workapp_entry : string string",
	"workapp_entry : string string string",
	"workapp_entry : string string string string",
	"workapp_entry : string string string string string",
	"curwork : LB string RB",
	"curwork : LB string string RB",
	"curwork : LB string string string RB",
	"curwork : LB string string string string RB",
	"defwork : LB string RB",
	"defwork : LB string string RB",
	"defwork : LB string string string RB",
	"defwork : LB string string string string RB",
	"win_list : LB win_entries RB",
	"win_entries : /* empty */",
	"win_entries : win_entries win_entry",
	"win_entry : string",
	"occupy_list : LB occupy_entries RB",
	"occupy_entries : /* empty */",
	"occupy_entries : occupy_entries occupy_entry",
	"occupy_entry : string",
	"occupy_entry : string occupy_workspc_list",
	"occupy_entry : WINDOW string",
	"occupy_entry : WINDOW string occupy_workspc_list",
	"occupy_entry : WORKSPACE string",
	"occupy_entry : WORKSPACE string occupy_window_list",
	"occupy_workspc_list : LB occupy_workspc_entries RB",
	"occupy_workspc_entries : /* empty */",
	"occupy_workspc_entries : occupy_workspc_entries occupy_workspc_entry",
	"occupy_workspc_entry : string",
	"occupy_window_list : LB occupy_window_entries RB",
	"occupy_window_entries : /* empty */",
	"occupy_window_entries : occupy_window_entries occupy_window_entry",
	"occupy_window_entry : string",
	"icon_list : LB icon_entries RB",
	"icon_entries : /* empty */",
	"icon_entries : icon_entries icon_entry",
	"icon_entry : string string",
	"function : LB function_entries RB",
	"function_entries : /* empty */",
	"function_entries : function_entries function_entry",
	"function_entry : action",
	"menu : LB menu_entries RB",
	"menu_entries : /* empty */",
	"menu_entries : menu_entries menu_entry",
	"menu_entry : string action",
	"menu_entry : string LP string COLON string RP action",
	"action : FKEYWORD",
	"action : FSKEYWORD string",
	"signed_number : number",
	"signed_number : PLUS number",
	"signed_number : MINUS number",
	"button : BUTTON number",
	"string : STRING",
	"number : NUMBER",
};
#endif /* YYDEBUG */
# line	1 "/usr/ccs/bin/yaccpar"
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)yaccpar	6.12	93/06/07 SMI"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yynewmax * sizeof(type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		yycvtok(yylex())
/*
** yycvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int yycvtok(int i)
#else
int yycvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( yymbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = yymbchars[mid].character;
			if( j==i ){/*Found*/ 
				return yymbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		yylex()
#endif/*!YYNMBCHARS*/

/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside switch should never be
	executed; yypvt is set to 0 to avoid "used before set" warning.
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto yyerrlab;
		case 2: goto yynewstate;
	}
	yypvt = 0;
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
			yyerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */
	goto yystack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			int yynewmax;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newyys = (char *)YYNEW(int);
				char *newyyv = (char *)YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
				yyerror( "yacc stack overflow" );
				YYABORT;
			}
			yymaxdepth = yynewmax;

			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
			skip_init:
				yynerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 9:
# line 149 "gram.y"
{
		      (void) AddIconRegion(yypvt[-4].ptr, yypvt[-3].num, yypvt[-2].num, yypvt[-1].num, yypvt[-0].num, "undef", "undef", "undef");
		  } break;
case 10:
# line 152 "gram.y"
{
		      (void) AddIconRegion(yypvt[-5].ptr, yypvt[-4].num, yypvt[-3].num, yypvt[-2].num, yypvt[-1].num, yypvt[-0].ptr, "undef", "undef");
		  } break;
case 11:
# line 155 "gram.y"
{
		      (void) AddIconRegion(yypvt[-6].ptr, yypvt[-5].num, yypvt[-4].num, yypvt[-3].num, yypvt[-2].num, yypvt[-1].ptr, yypvt[-0].ptr, "undef");
		  } break;
case 12:
# line 158 "gram.y"
{
		      (void) AddIconRegion(yypvt[-7].ptr, yypvt[-6].num, yypvt[-5].num, yypvt[-4].num, yypvt[-3].num, yypvt[-2].ptr, yypvt[-1].ptr, yypvt[-0].ptr);
		  } break;
case 13:
# line 161 "gram.y"
{
		      list = AddIconRegion(yypvt[-4].ptr, yypvt[-3].num, yypvt[-2].num, yypvt[-1].num, yypvt[-0].num, "undef", "undef", "undef");
		  } break;
case 15:
# line 165 "gram.y"
{
		      list = AddIconRegion(yypvt[-5].ptr, yypvt[-4].num, yypvt[-3].num, yypvt[-2].num, yypvt[-1].num, yypvt[-0].ptr, "undef", "undef");
		  } break;
case 17:
# line 169 "gram.y"
{
		      list = AddIconRegion(yypvt[-6].ptr, yypvt[-5].num, yypvt[-4].num, yypvt[-3].num, yypvt[-2].num, yypvt[-1].ptr, yypvt[-0].ptr, "undef");
		  } break;
case 19:
# line 173 "gram.y"
{
		      list = AddIconRegion(yypvt[-7].ptr, yypvt[-6].num, yypvt[-5].num, yypvt[-4].num, yypvt[-3].num, yypvt[-2].ptr, yypvt[-1].ptr, yypvt[-0].ptr);
		  } break;
case 21:
# line 178 "gram.y"
{
		      list = AddWindowRegion (yypvt[-2].ptr, yypvt[-1].num, yypvt[-0].num);
		  } break;
case 23:
# line 183 "gram.y"
{ if (Scr->FirstTime)
						  {
						    Scr->iconmgr->geometry= yypvt[-1].ptr;
						    Scr->iconmgr->columns=yypvt[-0].num;
						  }
						} break;
case 24:
# line 189 "gram.y"
{ if (Scr->FirstTime)
						    Scr->iconmgr->geometry = yypvt[-0].ptr;
						} break;
case 25:
# line 192 "gram.y"
{ if (Scr->FirstTime)
						  {
						    Scr->workSpaceMgr.workspaceWindow.geometry= yypvt[-1].ptr;
						    Scr->workSpaceMgr.workspaceWindow.columns=yypvt[-0].num;
						  }
						} break;
case 26:
# line 198 "gram.y"
{ if (Scr->FirstTime)
						    Scr->workSpaceMgr.workspaceWindow.geometry = yypvt[-0].ptr;
						} break;
case 27:
# line 201 "gram.y"
{} break;
case 29:
# line 204 "gram.y"
{} break;
case 31:
# line 207 "gram.y"
{ if (Scr->FirstTime)
					  {
						Scr->DoZoom = TRUE;
						Scr->ZoomCount = yypvt[-0].num;
					  }
					} break;
case 32:
# line 213 "gram.y"
{ if (Scr->FirstTime) 
						Scr->DoZoom = TRUE; } break;
case 33:
# line 215 "gram.y"
{} break;
case 34:
# line 216 "gram.y"
{} break;
case 35:
# line 217 "gram.y"
{ list = &Scr->IconifyByUn; } break;
case 37:
# line 219 "gram.y"
{ if (Scr->FirstTime) 
		    Scr->IconifyByUnmapping = TRUE; } break;
case 38:
# line 222 "gram.y"
{ list = &Scr->OpaqueMoveList; } break;
case 40:
# line 224 "gram.y"
{ if (Scr->FirstTime) Scr->DoOpaqueMove = TRUE; } break;
case 41:
# line 225 "gram.y"
{ list = &Scr->NoOpaqueMoveList; } break;
case 43:
# line 227 "gram.y"
{ if (Scr->FirstTime) Scr->DoOpaqueMove = FALSE; } break;
case 44:
# line 228 "gram.y"
{ list = &Scr->OpaqueMoveList; } break;
case 46:
# line 230 "gram.y"
{ if (Scr->FirstTime) Scr->DoOpaqueResize = TRUE; } break;
case 47:
# line 231 "gram.y"
{ list = &Scr->NoOpaqueResizeList; } break;
case 49:
# line 233 "gram.y"
{ if (Scr->FirstTime) Scr->DoOpaqueResize = FALSE; } break;
case 50:
# line 235 "gram.y"
{ 
					  GotTitleButton (yypvt[-2].ptr, yypvt[-0].num, False);
					} break;
case 51:
# line 238 "gram.y"
{ 
					  GotTitleButton (yypvt[-2].ptr, yypvt[-0].num, True);
					} break;
case 52:
# line 241 "gram.y"
{ CreateTitleButton(yypvt[-0].ptr, 0, NULL, NULL, FALSE, TRUE); } break;
case 54:
# line 243 "gram.y"
{ CreateTitleButton(yypvt[-0].ptr, 0, NULL, NULL, TRUE, TRUE); } break;
case 56:
# line 245 "gram.y"
{
		    root = GetRoot(yypvt[-0].ptr, NULLSTR, NULLSTR);
		    AddFuncButton (yypvt[-1].num, C_ROOT, 0, F_MENU, root, (MenuItem*) 0);
		} break;
case 57:
# line 249 "gram.y"
{
			if (yypvt[-0].num == F_MENU) {
			    pull->prev = NULL;
			    AddFuncButton (yypvt[-1].num, C_ROOT, 0, yypvt[-0].num, pull, (MenuItem*) 0);
			}
			else {
			    MenuItem *item;

			    root = GetRoot(TWM_ROOT,NULLSTR,NULLSTR);
			    item = AddToMenu (root, "x", Action,
					NULLSTR, yypvt[-0].num, NULLSTR, NULLSTR);
			    AddFuncButton (yypvt[-1].num, C_ROOT, 0, yypvt[-0].num, (MenuRoot*) 0, item);
			}
			Action = "";
			pull = NULL;
		} break;
case 58:
# line 265 "gram.y"
{ GotKey(yypvt[-1].ptr, yypvt[-0].num); } break;
case 59:
# line 266 "gram.y"
{ GotButton(yypvt[-1].num, yypvt[-0].num); } break;
case 60:
# line 268 "gram.y"
{ list = &Scr->DontIconify; } break;
case 62:
# line 270 "gram.y"
{} break;
case 64:
# line 272 "gram.y"
{ list = &Scr->OccupyAll; } break;
case 66:
# line 274 "gram.y"
{} break;
case 68:
# line 276 "gram.y"
{ list = &Scr->IconMgrNoShow; } break;
case 70:
# line 278 "gram.y"
{ Scr->IconManagerDontShow = TRUE; } break;
case 71:
# line 279 "gram.y"
{ list = &Scr->IconMgrs; } break;
case 73:
# line 281 "gram.y"
{ list = &Scr->IconMgrShow; } break;
case 75:
# line 283 "gram.y"
{ list = &Scr->NoTitleHighlight; } break;
case 77:
# line 285 "gram.y"
{ if (Scr->FirstTime)
						Scr->TitleHighlight = FALSE; } break;
case 78:
# line 287 "gram.y"
{ list = &Scr->NoHighlight; } break;
case 80:
# line 289 "gram.y"
{ if (Scr->FirstTime)
						Scr->Highlight = FALSE; } break;
case 81:
# line 291 "gram.y"
{ list = &Scr->AlwaysOnTopL; } break;
case 83:
# line 293 "gram.y"
{ list = &Scr->NoStackModeL; } break;
case 85:
# line 295 "gram.y"
{ if (Scr->FirstTime)
						Scr->StackMode = FALSE; } break;
case 86:
# line 297 "gram.y"
{ list = &Scr->NoBorder; } break;
case 88:
# line 299 "gram.y"
{ list = &Scr->NoIconTitle; } break;
case 90:
# line 301 "gram.y"
{ if (Scr->FirstTime)
						Scr->NoIconTitlebar = TRUE; } break;
case 91:
# line 303 "gram.y"
{ list = &Scr->NoTitle; } break;
case 93:
# line 305 "gram.y"
{ if (Scr->FirstTime)
						Scr->NoTitlebar = TRUE; } break;
case 94:
# line 307 "gram.y"
{ list = &Scr->MakeTitle; } break;
case 96:
# line 309 "gram.y"
{ list = &Scr->StartIconified; } break;
case 98:
# line 311 "gram.y"
{ list = &Scr->AutoRaise; } break;
case 100:
# line 313 "gram.y"
{ Scr->AutoRaiseDefault = TRUE; } break;
case 101:
# line 314 "gram.y"
{
					root = GetRoot(yypvt[-5].ptr, yypvt[-3].ptr, yypvt[-1].ptr); } break;
case 102:
# line 316 "gram.y"
{ root->real_menu = TRUE;} break;
case 103:
# line 317 "gram.y"
{ root = GetRoot(yypvt[-0].ptr, NULLSTR, NULLSTR); } break;
case 104:
# line 318 "gram.y"
{ root->real_menu = TRUE; } break;
case 105:
# line 319 "gram.y"
{ root = GetRoot(yypvt[-0].ptr, NULLSTR, NULLSTR); } break;
case 107:
# line 321 "gram.y"
{ list = &Scr->IconNames; } break;
case 109:
# line 323 "gram.y"
{ color = COLOR; } break;
case 111:
# line 325 "gram.y"
{} break;
case 113:
# line 327 "gram.y"
{ color = MONOCHROME; } break;
case 115:
# line 329 "gram.y"
{ Scr->DefaultFunction.func = yypvt[-0].num;
					  if (yypvt[-0].num == F_MENU)
					  {
					    pull->prev = NULL;
					    Scr->DefaultFunction.menu = pull;
					  }
					  else
					  {
					    root = GetRoot(TWM_ROOT,NULLSTR,NULLSTR);
					    Scr->DefaultFunction.item = 
						AddToMenu(root,"x",Action,
							  NULLSTR,yypvt[-0].num, NULLSTR, NULLSTR);
					  }
					  Action = "";
					  pull = NULL;
					} break;
case 116:
# line 345 "gram.y"
{ Scr->WindowFunction.func = yypvt[-0].num;
					   root = GetRoot(TWM_ROOT,NULLSTR,NULLSTR);
					   Scr->WindowFunction.item = 
						AddToMenu(root,"x",Action,
							  NULLSTR,yypvt[-0].num, NULLSTR, NULLSTR);
					   Action = "";
					   pull = NULL;
					} break;
case 117:
# line 353 "gram.y"
{ Scr->ChangeWorkspaceFunction.func = yypvt[-0].num;
					   root = GetRoot(TWM_ROOT,NULLSTR,NULLSTR);
					   Scr->ChangeWorkspaceFunction.item = 
						AddToMenu(root,"x",Action,
							  NULLSTR,yypvt[-0].num, NULLSTR, NULLSTR);
					   Action = "";
					   pull = NULL;
					} break;
case 118:
# line 361 "gram.y"
{ Scr->DeIconifyFunction.func = yypvt[-0].num;
					   root = GetRoot(TWM_ROOT,NULLSTR,NULLSTR);
					   Scr->DeIconifyFunction.item = 
						AddToMenu(root,"x",Action,
							  NULLSTR,yypvt[-0].num, NULLSTR, NULLSTR);
					   Action = "";
					   pull = NULL;
					} break;
case 119:
# line 369 "gram.y"
{ Scr->IconifyFunction.func = yypvt[-0].num;
					   root = GetRoot(TWM_ROOT,NULLSTR,NULLSTR);
					   Scr->IconifyFunction.item = 
						AddToMenu(root,"x",Action,
							  NULLSTR,yypvt[-0].num, NULLSTR, NULLSTR);
					   Action = "";
					   pull = NULL;
					} break;
case 120:
# line 377 "gram.y"
{ list = &Scr->WarpCursorL; } break;
case 122:
# line 379 "gram.y"
{ if (Scr->FirstTime) 
					    Scr->WarpCursor = TRUE; } break;
case 123:
# line 381 "gram.y"
{ list = &Scr->WindowRingL; } break;
case 125:
# line 383 "gram.y"
{ Scr->WindowRingAll = TRUE; } break;
case 126:
# line 386 "gram.y"
{ if (!do_single_keyword (yypvt[-0].num)) {
					    twmrc_error_prefix();
					    fprintf (stderr,
					"unknown singleton keyword %d\n",
						     yypvt[-0].num);
					    ParseError = 1;
					  }
					} break;
case 127:
# line 396 "gram.y"
{ if (!do_string_keyword (yypvt[-1].num, yypvt[-0].ptr)) {
					    twmrc_error_prefix();
					    fprintf (stderr,
				"unknown string keyword %d (value \"%s\")\n",
						     yypvt[-1].num, yypvt[-0].ptr);
					    ParseError = 1;
					  }
					} break;
case 128:
# line 404 "gram.y"
{ if (!do_string_keyword (yypvt[-0].num, defstring)) {
 					    twmrc_error_prefix();
 					    fprintf (stderr,
 				"unknown string keyword %d (no value)\n",
 						     yypvt[-0].num);
 					    ParseError = 1;
 					  }
 					} break;
case 129:
# line 414 "gram.y"
{ if (!do_number_keyword (yypvt[-1].num, yypvt[-0].num)) {
					    twmrc_error_prefix();
					    fprintf (stderr,
				"unknown numeric keyword %d (value %d)\n",
						     yypvt[-1].num, yypvt[-0].num);
					    ParseError = 1;
					  }
					} break;
case 130:
# line 426 "gram.y"
{ yyval.num = yypvt[-0].num; } break;
case 131:
# line 429 "gram.y"
{ yyval.num = yypvt[-0].num; } break;
case 134:
# line 436 "gram.y"
{ mods |= Mod1Mask; } break;
case 135:
# line 437 "gram.y"
{ mods |= ShiftMask; } break;
case 136:
# line 438 "gram.y"
{ mods |= LockMask; } break;
case 137:
# line 439 "gram.y"
{ mods |= ControlMask; } break;
case 138:
# line 440 "gram.y"
{ if (yypvt[-0].num < 1 || yypvt[-0].num > 5) {
					     twmrc_error_prefix();
					     fprintf (stderr, 
				"bad modifier number (%d), must be 1-5\n",
						      yypvt[-0].num);
					     ParseError = 1;
					  } else {
					     mods |= (Alt1Mask << (yypvt[-0].num - 1));
					  }
					} break;
case 139:
# line 450 "gram.y"
{ if (yypvt[-0].num < 1 || yypvt[-0].num > 5) {
					     twmrc_error_prefix();
					     fprintf (stderr, 
				"bad modifier number (%d), must be 1-5\n",
						      yypvt[-0].num);
					     ParseError = 1;
					  } else {
					     mods |= (Mod1Mask << (yypvt[-0].num - 1));
					  }
					} break;
case 140:
# line 460 "gram.y"
{ } break;
case 143:
# line 467 "gram.y"
{ cont |= C_WINDOW_BIT; } break;
case 144:
# line 468 "gram.y"
{ cont |= C_TITLE_BIT; } break;
case 145:
# line 469 "gram.y"
{ cont |= C_ICON_BIT; } break;
case 146:
# line 470 "gram.y"
{ cont |= C_ROOT_BIT; } break;
case 147:
# line 471 "gram.y"
{ cont |= C_FRAME_BIT; } break;
case 148:
# line 472 "gram.y"
{ cont |= C_ICONMGR_BIT; } break;
case 149:
# line 473 "gram.y"
{ cont |= C_ICONMGR_BIT; } break;
case 150:
# line 474 "gram.y"
{ cont |= C_ALTER_BIT; } break;
case 151:
# line 475 "gram.y"
{ cont |= C_ALL_BITS; } break;
case 152:
# line 476 "gram.y"
{  } break;
case 155:
# line 483 "gram.y"
{ cont |= C_WINDOW_BIT; } break;
case 156:
# line 484 "gram.y"
{ cont |= C_TITLE_BIT; } break;
case 157:
# line 485 "gram.y"
{ cont |= C_ICON_BIT; } break;
case 158:
# line 486 "gram.y"
{ cont |= C_ROOT_BIT; } break;
case 159:
# line 487 "gram.y"
{ cont |= C_FRAME_BIT; } break;
case 160:
# line 488 "gram.y"
{ cont |= C_ICONMGR_BIT; } break;
case 161:
# line 489 "gram.y"
{ cont |= C_ICONMGR_BIT; } break;
case 162:
# line 490 "gram.y"
{ cont |= C_ALL_BITS; } break;
case 163:
# line 491 "gram.y"
{ cont |= C_ALTER_BIT; } break;
case 164:
# line 492 "gram.y"
{ } break;
case 165:
# line 493 "gram.y"
{ Name = yypvt[-0].ptr; cont |= C_NAME_BIT; } break;
case 166:
# line 497 "gram.y"
{} break;
case 169:
# line 504 "gram.y"
{ ModifyCurrentTB(yypvt[-2].num, yypvt[-0].num, Action, pull);} break;
case 170:
# line 508 "gram.y"
{} break;
case 173:
# line 515 "gram.y"
{ SetHighlightPixmap (yypvt[-0].ptr); } break;
case 174:
# line 519 "gram.y"
{} break;
case 177:
# line 526 "gram.y"
{
			NewBitmapCursor(&Scr->FrameCursor, yypvt[-1].ptr, yypvt[-0].ptr); } break;
case 178:
# line 528 "gram.y"
{
			NewFontCursor(&Scr->FrameCursor, yypvt[-0].ptr); } break;
case 179:
# line 530 "gram.y"
{
			NewBitmapCursor(&Scr->TitleCursor, yypvt[-1].ptr, yypvt[-0].ptr); } break;
case 180:
# line 532 "gram.y"
{
			NewFontCursor(&Scr->TitleCursor, yypvt[-0].ptr); } break;
case 181:
# line 534 "gram.y"
{
			NewBitmapCursor(&Scr->IconCursor, yypvt[-1].ptr, yypvt[-0].ptr); } break;
case 182:
# line 536 "gram.y"
{
			NewFontCursor(&Scr->IconCursor, yypvt[-0].ptr); } break;
case 183:
# line 538 "gram.y"
{
			NewBitmapCursor(&Scr->IconMgrCursor, yypvt[-1].ptr, yypvt[-0].ptr); } break;
case 184:
# line 540 "gram.y"
{
			NewFontCursor(&Scr->IconMgrCursor, yypvt[-0].ptr); } break;
case 185:
# line 542 "gram.y"
{
			NewBitmapCursor(&Scr->ButtonCursor, yypvt[-1].ptr, yypvt[-0].ptr); } break;
case 186:
# line 544 "gram.y"
{
			NewFontCursor(&Scr->ButtonCursor, yypvt[-0].ptr); } break;
case 187:
# line 546 "gram.y"
{
			NewBitmapCursor(&Scr->MoveCursor, yypvt[-1].ptr, yypvt[-0].ptr); } break;
case 188:
# line 548 "gram.y"
{
			NewFontCursor(&Scr->MoveCursor, yypvt[-0].ptr); } break;
case 189:
# line 550 "gram.y"
{
			NewBitmapCursor(&Scr->ResizeCursor, yypvt[-1].ptr, yypvt[-0].ptr); } break;
case 190:
# line 552 "gram.y"
{
			NewFontCursor(&Scr->ResizeCursor, yypvt[-0].ptr); } break;
case 191:
# line 554 "gram.y"
{
			NewBitmapCursor(&Scr->WaitCursor, yypvt[-1].ptr, yypvt[-0].ptr); } break;
case 192:
# line 556 "gram.y"
{
			NewFontCursor(&Scr->WaitCursor, yypvt[-0].ptr); } break;
case 193:
# line 558 "gram.y"
{
			NewBitmapCursor(&Scr->MenuCursor, yypvt[-1].ptr, yypvt[-0].ptr); } break;
case 194:
# line 560 "gram.y"
{
			NewFontCursor(&Scr->MenuCursor, yypvt[-0].ptr); } break;
case 195:
# line 562 "gram.y"
{
			NewBitmapCursor(&Scr->SelectCursor, yypvt[-1].ptr, yypvt[-0].ptr); } break;
case 196:
# line 564 "gram.y"
{
			NewFontCursor(&Scr->SelectCursor, yypvt[-0].ptr); } break;
case 197:
# line 566 "gram.y"
{
			NewBitmapCursor(&Scr->DestroyCursor, yypvt[-1].ptr, yypvt[-0].ptr); } break;
case 198:
# line 568 "gram.y"
{
			NewFontCursor(&Scr->DestroyCursor, yypvt[-0].ptr); } break;
case 199:
# line 572 "gram.y"
{} break;
case 202:
# line 580 "gram.y"
{ if (!do_colorlist_keyword (yypvt[-1].num, color,
								     yypvt[-0].ptr)) {
					    twmrc_error_prefix();
					    fprintf (stderr,
			"unhandled list color keyword %d (string \"%s\")\n",
						     yypvt[-1].num, yypvt[-0].ptr);
					    ParseError = 1;
					  }
					} break;
case 203:
# line 589 "gram.y"
{ list = do_colorlist_keyword(yypvt[-1].num,color,
								      yypvt[-0].ptr);
					  if (!list) {
					    twmrc_error_prefix();
					    fprintf (stderr,
			"unhandled color list keyword %d (string \"%s\")\n",
						     yypvt[-1].num, yypvt[-0].ptr);
					    ParseError = 1;
					  }
					} break;
case 205:
# line 600 "gram.y"
{ if (!do_color_keyword (yypvt[-1].num, color,
								 yypvt[-0].ptr)) {
					    twmrc_error_prefix();
					    fprintf (stderr,
			"unhandled color keyword %d (string \"%s\")\n",
						     yypvt[-1].num, yypvt[-0].ptr);
					    ParseError = 1;
					  }
					} break;
case 206:
# line 611 "gram.y"
{} break;
case 209:
# line 618 "gram.y"
{ do_string_savecolor(color, yypvt[-0].ptr); } break;
case 210:
# line 619 "gram.y"
{ do_var_savecolor(yypvt[-0].num); } break;
case 211:
# line 622 "gram.y"
{} break;
case 214:
# line 629 "gram.y"
{ if (Scr->FirstTime &&
					      color == Scr->Monochrome)
					    AddToList(list, yypvt[-1].ptr, yypvt[-0].ptr); } break;
case 215:
# line 634 "gram.y"
{ 
				    if (HasShape) Scr->SqueezeTitle = TRUE;
				} break;
case 216:
# line 637 "gram.y"
{ list = &Scr->SqueezeTitleL; 
				  if (HasShape && Scr->SqueezeTitle == -1)
				    Scr->SqueezeTitle = TRUE;
				} break;
case 218:
# line 642 "gram.y"
{ Scr->SqueezeTitle = FALSE; } break;
case 219:
# line 643 "gram.y"
{ list = &Scr->DontSqueezeTitleL; } break;
case 222:
# line 648 "gram.y"
{
				if (Scr->FirstTime) {
				   do_squeeze_entry (list, yypvt[-3].ptr, yypvt[-2].num, yypvt[-1].num, yypvt[-0].num);
				}
			} break;
case 223:
# line 656 "gram.y"
{} break;
case 226:
# line 663 "gram.y"
{ if (Scr->FirstTime)
					    AddToList(list, yypvt[-2].ptr, (char *)
						AllocateIconManager(yypvt[-2].ptr, NULLSTR,
							yypvt[-1].ptr,yypvt[-0].num));
					} break;
case 227:
# line 669 "gram.y"
{ if (Scr->FirstTime)
					    AddToList(list, yypvt[-3].ptr, (char *)
						AllocateIconManager(yypvt[-3].ptr,yypvt[-2].ptr,
						yypvt[-1].ptr, yypvt[-0].num));
					} break;
case 228:
# line 676 "gram.y"
{} break;
case 231:
# line 683 "gram.y"
{
			AddWorkSpace (yypvt[-0].ptr, NULLSTR, NULLSTR, NULLSTR, NULLSTR, NULLSTR);
		} break;
case 232:
# line 686 "gram.y"
{
			curWorkSpc = yypvt[-0].ptr;
		} break;
case 234:
# line 692 "gram.y"
{} break;
case 237:
# line 699 "gram.y"
{
			AddWorkSpace (curWorkSpc, yypvt[-0].ptr, NULLSTR, NULLSTR, NULLSTR, NULLSTR);
		} break;
case 238:
# line 702 "gram.y"
{
			AddWorkSpace (curWorkSpc, yypvt[-1].ptr, yypvt[-0].ptr, NULLSTR, NULLSTR, NULLSTR);
		} break;
case 239:
# line 705 "gram.y"
{
			AddWorkSpace (curWorkSpc, yypvt[-2].ptr, yypvt[-1].ptr, yypvt[-0].ptr, NULLSTR, NULLSTR);
		} break;
case 240:
# line 708 "gram.y"
{
			AddWorkSpace (curWorkSpc, yypvt[-3].ptr, yypvt[-2].ptr, yypvt[-1].ptr, yypvt[-0].ptr, NULLSTR);
		} break;
case 241:
# line 711 "gram.y"
{
			AddWorkSpace (curWorkSpc, yypvt[-4].ptr, yypvt[-3].ptr, yypvt[-2].ptr, yypvt[-1].ptr, yypvt[-0].ptr);
		} break;
case 242:
# line 716 "gram.y"
{
		    WMapCreateCurrentBackGround (yypvt[-1].ptr, NULL, NULL, NULL);
		} break;
case 243:
# line 719 "gram.y"
{
		    WMapCreateCurrentBackGround (yypvt[-2].ptr, yypvt[-1].ptr, NULL, NULL);
		} break;
case 244:
# line 722 "gram.y"
{
		    WMapCreateCurrentBackGround (yypvt[-3].ptr, yypvt[-2].ptr, yypvt[-1].ptr, NULL);
		} break;
case 245:
# line 725 "gram.y"
{
		    WMapCreateCurrentBackGround (yypvt[-4].ptr, yypvt[-3].ptr, yypvt[-2].ptr, yypvt[-1].ptr);
		} break;
case 246:
# line 730 "gram.y"
{
		    WMapCreateDefaultBackGround (yypvt[-1].ptr, NULL, NULL, NULL);
		} break;
case 247:
# line 733 "gram.y"
{
		    WMapCreateDefaultBackGround (yypvt[-2].ptr, yypvt[-1].ptr, NULL, NULL);
		} break;
case 248:
# line 736 "gram.y"
{
		    WMapCreateDefaultBackGround (yypvt[-3].ptr, yypvt[-2].ptr, yypvt[-1].ptr, NULL);
		} break;
case 249:
# line 739 "gram.y"
{
		    WMapCreateDefaultBackGround (yypvt[-4].ptr, yypvt[-3].ptr, yypvt[-2].ptr, yypvt[-1].ptr);
		} break;
case 250:
# line 744 "gram.y"
{} break;
case 253:
# line 751 "gram.y"
{ if (Scr->FirstTime)
					    AddToList(list, yypvt[-0].ptr, 0);
					} break;
case 254:
# line 756 "gram.y"
{} break;
case 257:
# line 763 "gram.y"
{client = yypvt[-0].ptr;} break;
case 259:
# line 765 "gram.y"
{client = yypvt[-0].ptr;} break;
case 261:
# line 767 "gram.y"
{workspace = yypvt[-0].ptr;} break;
case 263:
# line 771 "gram.y"
{} break;
case 266:
# line 778 "gram.y"
{
				AddToClientsList (yypvt[-0].ptr, client);
			  } break;
case 267:
# line 782 "gram.y"
{} break;
case 270:
# line 789 "gram.y"
{
				AddToClientsList (workspace, yypvt[-0].ptr);
			  } break;
case 271:
# line 793 "gram.y"
{} break;
case 274:
# line 800 "gram.y"
{ if (Scr->FirstTime) AddToList(list, yypvt[-1].ptr, yypvt[-0].ptr); } break;
case 275:
# line 803 "gram.y"
{} break;
case 278:
# line 810 "gram.y"
{ AddToMenu(root, "", Action, NULLSTR, yypvt[-0].num,
						NULLSTR, NULLSTR);
					  Action = "";
					} break;
case 279:
# line 816 "gram.y"
{lastmenuitem = (MenuItem*) 0;} break;
case 282:
# line 823 "gram.y"
{
			if (yypvt[-0].num == F_SEPARATOR) {
			    if (lastmenuitem) lastmenuitem->separated = 1;
			}
			else {
			    lastmenuitem = AddToMenu(root, yypvt[-1].ptr, Action, pull, yypvt[-0].num, NULLSTR, NULLSTR);
			    Action = "";
			    pull = NULL;
			}
		} break;
case 283:
# line 833 "gram.y"
{
			if (yypvt[-0].num == F_SEPARATOR) {
			    if (lastmenuitem) lastmenuitem->separated = 1;
			}
			else {
			    lastmenuitem = AddToMenu(root, yypvt[-6].ptr, Action, pull, yypvt[-0].num, yypvt[-4].ptr, yypvt[-2].ptr);
			    Action = "";
			    pull = NULL;
			}
		} break;
case 284:
# line 845 "gram.y"
{ yyval.num = yypvt[-0].num; } break;
case 285:
# line 846 "gram.y"
{
				yyval.num = yypvt[-1].num;
				Action = yypvt[-0].ptr;
				switch (yypvt[-1].num) {
				  case F_MENU:
				    pull = GetRoot (yypvt[-0].ptr, NULLSTR,NULLSTR);
				    pull->prev = root;
				    break;
				  case F_WARPRING:
				    if (!CheckWarpRingArg (Action)) {
					twmrc_error_prefix();
					fprintf (stderr,
			"ignoring invalid f.warptoring argument \"%s\"\n",
						 Action);
					yyval.num = F_NOP;
				    }
				  case F_WARPTOSCREEN:
				    if (!CheckWarpScreenArg (Action)) {
					twmrc_error_prefix();
					fprintf (stderr, 
			"ignoring invalid f.warptoscreen argument \"%s\"\n", 
					         Action);
					yyval.num = F_NOP;
				    }
				    break;
				  case F_COLORMAP:
				    if (CheckColormapArg (Action)) {
					yyval.num = F_COLORMAP;
				    } else {
					twmrc_error_prefix();
					fprintf (stderr,
			"ignoring invalid f.colormap argument \"%s\"\n", 
						 Action);
					yyval.num = F_NOP;
				    }
				    break;
				} /* end switch */
				   } break;
case 286:
# line 887 "gram.y"
{ yyval.num = yypvt[-0].num; } break;
case 287:
# line 888 "gram.y"
{ yyval.num = yypvt[-0].num; } break;
case 288:
# line 889 "gram.y"
{ yyval.num = -(yypvt[-0].num); } break;
case 289:
# line 892 "gram.y"
{ yyval.num = yypvt[-0].num;
					  if (yypvt[-0].num == 0)
						yyerror("bad button 0");

					  if (yypvt[-0].num > MAX_BUTTONS)
					  {
						yyval.num = 0;
						yyerror("button number too large");
					  }
					} break;
case 290:
# line 904 "gram.y"
{ ptr = (char *)malloc(strlen(yypvt[-0].ptr)+1);
					  strcpy(ptr, yypvt[-0].ptr);
					  RemoveDQuote(ptr);
					  yyval.ptr = ptr;
					} break;
case 291:
# line 909 "gram.y"
{ yyval.num = yypvt[-0].num; } break;
# line	532 "/usr/ccs/bin/yaccpar"
	}
	goto yystack;		/* reset registers in driver code */
}

